/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>
#include <ESP8266mDNS.h>
#include <EEPROM.h>
#include "FS.h"
#include <ESP8266FtpServer.h>

const char* serverIndex = "<form method='POST' action='/update' enctype='multipart/form-data'><input type='file' name='update'><input type='submit' value='Update'></form>";
char* tmp_log;
String inputString = "";         // a string to hold incoming data
boolean stringComplete = false;  // whether the string is complete
 int time_out,Wifi_connected;
MDNSResponder mdns;

ESP8266WebServer server(80);
FtpServer ftpSrv;   //set #define FTP_DEBUG in ESP8266FtpServer.h to see ftp verbose on serial

  #define MAX_SRV_CLIENTS 3
  const char* ssid = "TP-LINK_F150"; //Hier het Wifi netwerk
  const char* password = "xxxxxxx";//Hier het Wifi paswoord 
  IPAddress Ip(192, 168, 0, 65);       //    My Ip
  IPAddress Gw(192, 168, 0, 1);         //   My gateway
  IPAddress NMask(255, 255, 255, 0);   // My Mask


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void Webserver_start_up(){

  // Station, access to local router
    WiFi.disconnect();
    
    IPAddress lip(192, 168, 0, 65); // set gateway to fix IP-adres
    IPAddress lgateway(192, 168, 0, 1); // set gateway to match telenet router
    IPAddress lsubnet(255, 255, 255, 0); // set subnet mask to match your router
    WiFi.config(lip, lgateway, lsubnet);

    WiFi.mode(WIFI_STA);
    Serial.println(ssid);
    Serial.println(password);
    WiFi.begin(ssid, password);
   
    while ((WiFi.status() != WL_CONNECTED)&(time_out<20)) {
      delay(1000);
      Serial.print(".");
      time_out++;
    }
    if(time_out<20){
      Serial.println("Server started");
      server.begin(); //Waarschijnlijk niet nodig indien off-line
      Serial.println("");
      Serial.println("WiFi connected");
      Serial.println(WiFi.localIP()); //  Print the IP address
      Serial.print("After ");
      Serial.print(time_out);
      Serial.print (" s\n");
      Wifi_connected=1;
      }
    else{
      Serial.println("No connection to server, start with logging"); 
      Serial.println("Wifi will be switched off"); 
      WiFi.disconnect();
      WiFi.mode(WIFI_OFF);
      Wifi_connected=0;
    }
  //---------------- Server init

 
//  Serial.print("HTTP server started as : ");
//  Serial.println(host);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void do_log(){

        File f_log = SPIFFS.open("/log.txt","a+");
        f_log.print(inputString);
        f_log.close();
 
  }

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void setup() {
  pinMode(BUILTIN_LED, OUTPUT);  // initialize onboard LED as output
  digitalWrite(BUILTIN_LED, HIGH);  // turn on LED with voltage HIGH
  Serial.begin(38400);
  // reserve 255 bytes for the inputString:
  inputString.reserve(255);
  Webserver_start_up();//check for local LAN, if not switch off Wifi

   //   en andere dingen

  if (SPIFFS.begin()) {
    Serial.println("SPIFFS opened !");
    if(Wifi_connected) {
          ftpSrv.begin("Mini","Mini");    //username, password for ftp.  set ports in ESP8266FtpServer.h  (default 21, 50009 for PASV)
          Serial.println("ftp Server is booting");
          }
    
   
  }   

   //   en de rest
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void loop() {
  server.handleClient();
  ftpSrv.handleFTP();        //make sure in loop you call handleFTP()!! 
  serialEvent();
   if (stringComplete) {
      Serial.println(inputString);
      do_log();
      // clear the string:
      inputString = "";
      stringComplete = false;
      digitalWrite(BUILTIN_LED, LOW);   // turn off LED with voltage LOW
      }
  
   //   en de rest
  }

/*
  SerialEvent occurs whenever a new data comes in the hardware serial RX.  This routine is run between each
 time loop() runs, so using delay inside loop can delay response.  Multiple bytes of data may be available.
 As the Rx port is connected tot the CH340 with a resistance of 470, you can directly overrule this with your logging Rx.
 For flashing, you have to disconnect your logging Rx signal !
 */
void serialEvent() {
  while (Serial.available()) {
    // get the new byte:
     digitalWrite(BUILTIN_LED, HIGH);  // turn on LED with voltage HIGH
    char inChar = (char)Serial.read();
    // add it to the inputString:
    inputString += inChar;
    // if the incoming character is a newline, set a flag
    // so the main loop can do something about it:
    if (inChar == '\n') {
      stringComplete = true;
    }
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

